<?php
require_once 'FacebookPost.php';
require_once 'GroupService.php';

class FacebookGroupService implements GroupService {
	
	public static $token;
	public static $cacheFolder;
	public static $cacheTime;
	
	public static function getGroupPosts($groupId) {
		
		//caching
		$cacheFolder = self::$cacheFolder;
		$cacheTime = self::$cacheTime;
		$fmtime = @filemtime("$cacheFolder/fb$groupId");
		if ($fmtime === false || time() - $fmtime > $cacheTime)
		{
			$token = self::$token;
			$json = file_get_contents("https://graph.facebook.com/$groupId/feed?access_token=$token");
			file_put_contents("$cacheFolder/fb$groupId", $json);
		} 
		else 
		{
			$json = file_get_contents("$cacheFolder/fb$groupId");
		}
		$objs = json_decode($json);
		$objs = $objs->data;
		
		$result = array();		
		foreach ($objs as $obj) {
			$post = new FacebookPost();
			$post->setAuthor($obj->from->name);			
			$post->setCreationDate(date("Y-m-d H:i:s", strtotime($obj->created_time)));
			if (isset($obj->message))
				$post->setMessage($obj->message);
			if (!isset($obj->message) && isset($obj->caption))
				$post->setMessage($obj->caption);			
			if (isset($obj->link))
				$post->setLink($obj->link);
			if (isset($obj->comments->count) && $obj->comments->count > 0) {
				
				$comments = array();
				foreach ($obj->comments->data as $c) {
					
					$comment = new FacebookPost();
					$comment->setAuthor($c->from->name);
					$comment->setCreationDate(date("Y-m-d H:i:s", strtotime($c->created_time)));
					if (isset($c->message))
						$comment->setMessage($c->message);
					if (isset($c->link))
						$comment->setLink($c->link);					
					if (isset($c->likes))
						$comment->setLikes($c->likes);
					$post->addReply($comment);
				}
			}
			if (isset($obj->likes))
				$post->setLikes($obj->likes->count);
			
			$post->setReference("http://www.facebook.com/{$obj->id}");
			$result[] = $post;
		}
		
		return $result;
	}
	
	
}