<?php
require_once "GoogleGroupsPost.php";
require_once "libs/simplepie/autoloader.php";

class GoogleGroupsService implements GroupService {
	
	public static function getGroupPosts($groupId) {
		
		$feed = new SimplePie();
		$feed->set_feed_url("https://groups.google.com/group/$groupId/feed/rss_v2_0_topics.xml");
		$feed->init();
		$feed->handle_content_type();
		$feed->get_items();

		$result = array();
		foreach ($feed->get_items() as $item) {
			/* @var $item SimplePie_Item */
			$post = new GoogleGroupsPost();
			$post->setAuthor($item->get_author()->email);
			$post->setCreationDate($item->get_date("Y-m-d H:i:s"));
			$post->setMessage($item->get_content());
			$post->setTitle($item->get_title());
			$post->setReference($item->get_permalink());
			
			$result[$item->get_id()."/"] = $post;
		}
		
		$feed = new SimplePie();
		$feed->set_feed_url("https://groups.google.com/group/$groupId/feed/rss_v2_0_msgs.xml");
		$feed->init();
		$feed->handle_content_type();
		$feed->get_items();

		$replies = array();
		foreach (array_reverse($feed->get_items()) as $item) {
			/* @var $item SimplePie_Item */
			$post = new GoogleGroupsPost();
			$post->setAuthor($item->get_author()->email);
			$post->setCreationDate($item->get_date("Y-m-d H:i:s"));
			$post->setMessage($item->get_content());
			$post->setTitle($item->get_title());
			$post->setReference($item->get_permalink());
			
			preg_match("#http://groups\.google\.com/group/informatica-aq/browse_thread/thread/.+/#", $item->get_permalink(), $matches);		
			if (isset($result[$matches[0]])) {
				$p = $result[$matches[0]];
				if ($p->getReference() != $post->getReference())
					$p->addReply($post);
					//$replies[$p->getReference()][] = $post;
			}						
		}
		
// 		foreach ($result as $r) 
// 			if (isset($replies[$r->getReference()])) 
// 				foreach ($replies[$r->getReference()] as $reply)
// 					$r->addReply($reply);		
		
		return $result;
	}
	
}